// Copyright 2017 Google Inc. All Rights Reserved.
//
// Use of this source code is governed by an MIT-style
// license that can be found in the LICENSE file or at
// https://opensource.org/licenses/MIT.

#include "color_correlation.h"
#include "huffman_decode.h"

#include "common.h"
#include "quantizer.h"

namespace pik {

/* FindIndexOfSumMaximum() removed */

/* FindBestCorrelation() removed */

/* UnapplyColorCorrelationAC() removed */

/* ApplyColorCorrelationDC() removed */

/* ApplyColorCorrelationDC<true>() removed */

/* ApplyColorCorrelationDC<false>() removed */

/* FindBestColorCorrelationMap() removed */

bool DecodeColorMap(BitReader* PIK_RESTRICT br, ImageI* PIK_RESTRICT ac_map,
                    int* PIK_RESTRICT dc_val) {
  HuffmanDecodingData entropy;
  if (!entropy.ReadFromBitStream(br)) {
    return PIK_FAILURE("Invalid histogram data.");
  }
  HuffmanDecoder decoder;
  br->FillBitBuffer();
  *dc_val = decoder.ReadSymbol(entropy, br);
  for (size_t y = 0; y < ac_map->ysize(); ++y) {
    int* PIK_RESTRICT row = ac_map->Row(y);
    for (size_t x = 0; x < ac_map->xsize(); ++x) {
      br->FillBitBuffer();
      row[x] = decoder.ReadSymbol(entropy, br);
    }
  }
  PIK_RETURN_IF_ERROR(br->JumpToByteBoundary());
  return true;
}

/* EncodeColorMap() removed */

}  // namespace pik
