// Copyright 2017 Google Inc. All Rights Reserved.
//
// Use of this source code is governed by an MIT-style
// license that can be found in the LICENSE file or at
// https://opensource.org/licenses/MIT.

#include "dpik.h"

#include <stddef.h>
#include <stdio.h>
#include <string.h>

#include "data_parallel.h"

#include "arch_specific.h"
#include "common.h"
#include "image.h"
#include "os_specific.h"
#include "padded_bytes.h"
#include "pik.h"
#include "pik_info.h"
#include "simd/targets.h"

namespace pik {

/* DecompressArgs::DecompressArgs() removed */

/* DecompressArgs::AddCommandLineOptions() removed */

/* DecompressArgs::ValidateArgs() removed */

/* DecompressStats::NotifyElapsed() removed */

/* DecompressStats::Print() removed */

/* DecompressStats::SimmarizeElapsed() removed */

// Called num_reps times.
Status Decompress(const PaddedBytes& compressed, const DecompressParams& params,
                  ThreadPool* pool, CodecInOut* PIK_RESTRICT io,
                  size_t* downsampling) {
  PikInfo info;
  if (!PikToPixels(params, compressed, io, &info, pool)) {
    return false;
  }
  *downsampling = info.downsampling;
  return true;
}

/* WriteOutput() removed */

}  // namespace pik
