// Copyright 2017 Google Inc. All Rights Reserved.
//
// Use of this source code is governed by an MIT-style
// license that can be found in the LICENSE file or at
// https://opensource.org/licenses/MIT.

#include "headers.h"

#include "fields.h"

namespace pik {

Alpha::Alpha() { Bundle::Init(this); }
ProjectiveTransformParams::ProjectiveTransformParams() { Bundle::Init(this); }
TileHeader::TileHeader() { Bundle::Init(this); }
GroupHeader::GroupHeader() { Bundle::Init(this); }
FrameInfo::FrameInfo() { Bundle::Init(this); }
FrameHeader::FrameHeader() { Bundle::Init(this); }
Preview::Preview() { Bundle::Init(this); }
Animation::Animation() { Bundle::Init(this); }
FileHeader::FileHeader() { Bundle::Init(this); }

/* CanEncode(const TileHeader& ...) removed */
/* CanEncode(const GroupHeader& ...) removed */
/* CanEncode(const FrameHeader& ...) removed */
/* CanEncode(const FileHeader& ...) removed */

/* ReadTileHeader() removed */

Status ReadGroupHeader(BitReader* PIK_RESTRICT reader,
                       GroupHeader* PIK_RESTRICT group) {
  return Bundle::Read(reader, group);
}
Status ReadPassHeader(BitReader* PIK_RESTRICT reader,
                      FrameHeader* PIK_RESTRICT pass) {
  return Bundle::Read(reader, pass);
}
Status ReadFileHeader(BitReader* PIK_RESTRICT reader,
                      FileHeader* PIK_RESTRICT file) {
  return Bundle::Read(reader, file);
}

/* WriteTileHeader() removed */
/* WriteGroupHeader() removed */
/* WritePassHeader() removed */
/* WriteFileHeader() removed */

/* MakeFileHeader() removed */

}  // namespace pik
