// Copyright 2019 Google LLC
//
// Use of this source code is governed by an MIT-style
// license that can be found in the LICENSE file or at
// https://opensource.org/licenses/MIT.

// @author Alexander Rhatushnyak

#ifndef PIK_LOSSLESS16_H_
#define PIK_LOSSLESS16_H_

#include "image.h"
#include "padded_bytes.h"

namespace pik {

// *compress appends to `bytes`.
// *decompress starts at byte offset `*pos` and sets `*pos` to point to the
// first unconsumed byte.
/* Grayscale16bit_compress() removed */
bool Grayscale16bit_decompress(const PaddedBytes& bytes, size_t* pos,
                               ImageU* result);

/* Colorful16bit_compress() removed */
bool Colorful16bit_decompress(const PaddedBytes& bytes, size_t* pos,
                              Image3U* result);
}  // namespace pik

#endif  // PIK_LOSSLESS16_H_
