// Copyright 2019 Google Inc. All Rights Reserved.
//
// Use of this source code is governed by an MIT-style
// license that can be found in the LICENSE file or at
// https://opensource.org/licenses/MIT.

#ifndef PIK_LOSSLESS_ENTROPY_H_
#define PIK_LOSSLESS_ENTROPY_H_

#include "padded_bytes.h"

namespace pik {

/* encodeVarInt() removed */

size_t decodeVarInt(const uint8_t* input, size_t inputSize, size_t* pos);

// TODO(janwas): output to PaddedBytes for compatibility with brotli.h.

/* MaybeEntropyEncode() removed */

// Does not know or return the compressed size, must be known from external
// source.
bool MaybeEntropyDecode(const uint8_t* data, size_t size, size_t out_capacity,
                        uint8_t* out, size_t* out_size);

}  // namespace pik

#endif  // PIK_LOSSLESS_ENTROPY_H_
