// Copyright 2019 Google LLC
//
// Use of this source code is governed by an MIT-style
// license that can be found in the LICENSE file or at
// https://opensource.org/licenses/MIT.

#ifndef PIK_NOISE_H_
#define PIK_NOISE_H_

// Noise synthesis. Currently disabled.

#include "bit_reader.h"
#include "image.h"

namespace pik {

struct NoiseParams {
  // Parameters of the fitted noise curve.
  // alpha * x ^ gamma + beta,
  // where x is an intensity of pixel / mean intensity of patch
  float alpha = 0.0f;
  float gamma = 0.0f;
  float beta = 0.0f;
};

struct NoiseLevel {
  float noise_level;
  float intensity;
};

// Add a noise to Opsin image
void AddNoise(const NoiseParams& noise_params, Image3F* opsin);

/* GetNoiseParameter() removed */

/* EncodeNoise() removed */

bool DecodeNoise(BitReader* br, NoiseParams* noise_params);

/* GetTextureStrength() removed */

/* GetThresholdFlatIndices() removed */

/* GetNoiseLevel() removed */

/* OptimizeNoiseParameters() removed */

}  // namespace pik

#endif  // PIK_NOISE_H_
