// Copyright 2017 Google Inc. All Rights Reserved.
//
// Use of this source code is governed by an MIT-style
// license that can be found in the LICENSE file or at
// https://opensource.org/licenses/MIT.

#ifndef PIK_PIK_PASS_H_
#define PIK_PIK_PASS_H_

#include "codec.h"
#include "compressed_image.h"
#include "data_parallel.h"
#include "headers.h"
#include "multipass_handler.h"
#include "padded_bytes.h"
#include "pik_info.h"
#include "pik_params.h"
#include "quantizer.h"
#include "status.h"

// Encode and decode a single pass of an image. A pass can be either a
// decomposition of an image (eg. DC-only pass), or a frame in an animation.
// The behaviour of the (en/de)coder is defined by the given multipass_manager.

namespace pik {

/* struct FrameParams removed */

// These process each group in parallel.

/* PixelsToPikPass() removed */

// Decodes an input image from a byte stream, using `file_header`.
// See PikToPixels for explanation of `io` color space.
Status PikPassToPixels(DecompressParams params, const PaddedBytes& compressed,
                       const FileHeader& file_header, ThreadPool* pool,
                       BitReader* reader, CodecInOut* io, PikInfo* aux_out,
                       MultipassManager* multipass_manager);

}  // namespace pik

#endif  // PIK_PIK_PASS_H_
