// Copyright 2017 Google Inc. All Rights Reserved.
//
// Use of this source code is governed by an MIT-style
// license that can be found in the LICENSE file or at
// https://opensource.org/licenses/MIT.

#ifndef PIK_SIZE_CODER_H_
#define PIK_SIZE_CODER_H_

#include <cstddef>
#include <cstdint>
#include "fields.h"
#include "status.h"

namespace pik {

template <uint32_t kDistribution>
class SizeCoderT {
 public:
  static size_t MaxSize(const size_t num_sizes) {
    const size_t bits = U32Coder::MaxEncodedBits(kDistribution) * num_sizes;
    return DivCeil(bits, kBitsPerByte);
  }

  /* Encode() removed */

  static size_t Decode(BitReader* reader) {
    return U32Coder::Read(kDistribution, reader);
  }
};

}  // namespace pik

#endif  // PIK_SIZE_CODER_H_
